/*
 * Created on 2005/04/20
 */
package roomlayout;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Date;
import java.util.Vector;

import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * @author kwsk
 */
public class UserStudy extends JPanel
{
    private RoomModel model;
    private RoomView view;
    
    private Vector list;
    
    private long startTime = -1;
    private long endTime = -1;
    
    private JComboBox comboBox;
    private JButton buttonStart, buttonEnd;
    private JLabel labelCompletionTime, labelError;
    private JTextField textFieldCompletionTime, textFieldError;
    
    public UserStudy(RoomModel model, RoomView view) {
        super(new BorderLayout());
        
        this.model = model;
        this.view = view;
        
        initList();
        
        JPanel panel0 = new JPanel();
        add(panel0, BorderLayout.NORTH);
        
        JLabel label = new JLabel("^XN");
        panel0.add(label);
        
        comboBox = new JComboBox(list);
        comboBox.setEnabled(true);
        panel0.add(comboBox);
        
        buttonStart = new JButton(new StartAction());
        buttonStart.setEnabled(true);
        panel0.add(buttonStart);
        
        buttonEnd = new JButton(new EndAction());
        buttonEnd.setEnabled(false);
        panel0.add(buttonEnd);
        

        JPanel panel1 = new JPanel(new GridLayout(3, 2, 10, 10));
        JPanel panel1Container = new JPanel(new BorderLayout());
        panel1Container.add(panel1, BorderLayout.NORTH);
        add(panel1Container, BorderLayout.CENTER);
        
        labelCompletionTime = new JLabel("Ǝ(b)");
        panel1.add(labelCompletionTime);
        
        textFieldCompletionTime = new JTextField();
        textFieldCompletionTime.setEditable(false);
        panel1.add(textFieldCompletionTime);
        
        labelError = new JLabel("덷");
        panel1.add(labelError);
        
        textFieldError = new JTextField();
        textFieldError.setEditable(false);
        panel1.add(textFieldError);
        
//      labelPositionError = new JLabel("ʒu덷");
//      panel1.add(labelPositionError);
//      
//      textFieldPositionError = new JTextField();
//      textFieldPositionError.setEditable(false);
//      panel1.add(textFieldPositionError);
//
//        labelAngleError = new JLabel("px덷");
//        panel1.add(labelAngleError);
//
//        textFieldAngleError = new JTextField();
//        textFieldAngleError.setEditable(false);
//        panel1.add(textFieldAngleError);
        
    }
    
    private void initList() {
        list = new Vector();
        try {
            BufferedReader reader = new BufferedReader(new FileReader("data/tasklist.txt"));
            while(true) {
                String s = reader.readLine();
                if(s == null) break;
                list.add(s);
            }
            reader.close();
        }
        catch(IOException e) {
            e.printStackTrace();
        }
    }
    
    private class StartAction extends AbstractAction {
        public StartAction() {
            super("Jn");
        }
        public void actionPerformed(ActionEvent e) {
            comboBox.setEnabled(false);
            buttonStart.setEnabled(false);
            buttonEnd.setEnabled(true);
            
            String task = (String)comboBox.getSelectedItem();

            String filename = "data/" + task + ".before.txt";
            model.load(filename);
            view.repaint();
            
            textFieldCompletionTime.setText("");
            textFieldError.setText("");

            
            startTime = System.currentTimeMillis();
            Log.println("Start: " + task  + " at " + startTime + " (" + new Date() +")");
        }
    }
    
    private class EndAction extends AbstractAction {
        public EndAction() {
            super("I");
        }
        public void actionPerformed(ActionEvent e) {
            comboBox.setEnabled(true);
            buttonStart.setEnabled(true);
            buttonEnd.setEnabled(false);
            
            String task = (String)comboBox.getSelectedItem();

            endTime = System.currentTimeMillis();
            Log.println("End: " + task  + " at " + endTime + " (" + new Date() +")");

            model.save("data/" + task + "." + endTime + ".txt");
            
            String filename = "data/" + task + ".after.txt";
            RoomModel after = new RoomModel(filename);
            
            
            int completionTime = (int)((endTime - startTime) / 1000);
            int error = model.error(after);
            
            textFieldCompletionTime.setText(Integer.toString(completionTime));
            textFieldError.setText(Integer.toString(error));
            
            Log.println("Result:");
            Log.println("  task completion time = " + completionTime + " s");
            Log.println("  error = " + error);
        }
    }
}
